
%define falcon 0
%define smoke 1
# php, ruby and csharp depend on smoke
%define php 1
%define ruby 1
# arch'es matching mono's Arch set
%ifnarch sparc64
%define csharp 1
%endif
%define java 0
%define perl 1

%global ruby_sitelib %(ruby -rrbconfig -e 'puts Config::CONFIG["sitelibdir"]')
%global ruby_sitearch %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"]')
#lobal python_ver %(%{__python} -c "import sys ; print sys.version[:3]")
%define python_ver 2.6
%define            __python        python%{python_ver}
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Distribution:	CCux
Packager:  	Karsten Brockmann <arcam@ccux-linux.de>

Summary:   	K Desktop Environment - bindings to different programming languages
Name:      	kdebindings
Version:	4.5.4
Release:	1
BuildArch:	i686
License: 	LGPL
URL:		http://www.kde.org
Group:     	Graphical Desktop/KDE       
Source0: 	%{name}-%{version}.tar.bz2
# fix compilation against newer python26-sip python26-pyqt
Patch0:		kdebindings-4.5.1-sip_api_8.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildArch:	i686
BuildRequires:  python26-pyqt-devel
BuildRequires:  automoc4
#BuildRequires:  kdepim-runtime-devel
BuildRequires:  kdegraphics-devel
BuildRequires:	kdegraphics-libs
BuildRequires:  qimageblitz-devel 
BuildRequires:  kdebase-workspace-devel
BuildRequires:  akonadi-devel
BuildRequires:  QScintilla-devel
BuildRequires:  boost-devel
BuildRequires:  qca-devel
BuildRequires:  mesa-libGL-devel
BuildRequires:  mesa-libGLU-devel
BuildRequires:  shared-desktop-ontologies
BuildRequires:  attica-devel
%if 0%{?csharp}
BuildRequires:	monodoc-devel
BuildRequires:  mono-core-devel
%endif
%if 0%{?ruby}
BuildRequires:  ruby
BuildRequires:  ruby-devel
%endif
%if 0%{?perl}
BuildRequires:  perl
%endif
BuildRequires:  qwt-devel
BuildRequires:	gdbm-devel
BuildRequires:  db-devel
BuildRequires:  libxml2-devel
BuildRequires:  libXxf86vm-devel
BuildRequires:  libXdamage-devel

# weird rpm dependency problem 
# fixes can`t install google-gadgets - nothing provides libsoup-2.4.so.1
# even if it exists
BuildRequires:	libsoup-devel

#Automatically resolved build dependencies
BuildRequires: coreutils
BuildRequires: glibc-devel
BuildRequires: kdelibs-devel
BuildRequires: kdepimlibs-devel
BuildRequires: libgcc
BuildRequires: libstdc++-devel
BuildRequires: phonon-devel
BuildRequires: python26-devel
BuildRequires: qt4-devel
BuildRequires: soprano-devel

%description
The kdebindings provides the ability to write KDE applications in a variety of languages including Ruby, Perl, Python, Java, JavaScript, C#, and Smoke.

%if %{csharp}
%package mono
Summary:        KDE4 bindings for mono
Group:          Graphical Desktop/KDE

%description mono
KDE4 bindings for mono (Kimono / Qyoto / SMOKE2)
%endif

%package python
Summary:        KDE4 bindings for python
Group:          Graphical Desktop/KDE

%description python
KDE4 bindings for python (PyKDE4)

%if %{ruby}
%package ruby
Summary:        KDE4 bindings for ruby
Group:          Graphical Desktop/KDE

%description ruby
KDE4 bindings for ruby
%endif

%if %{smoke}
%package smoke
Summary:        KDE4 bindings for smoke
Group:          Graphical Desktop/KDE
#BuildRequires:	kdebindings-smoke

%description smoke
KDE4 bindings for smoke
%endif

%if %{perl}
%package perl
Summary:        KDE4 bindings for perl
Group:          Graphical Desktop/KDE

%description perl
KDE4 bindings for perl
%endif

%post
ldconfig

%postun
ldconfig

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

%build
FLAGS="$RPM_OPT_FLAGS -DNDEBUG -DNO_DEBUG"
export CFLAGS="$FLAGS"
export CXXFLAGS="$FLAGS"
mkdir -p %{_target_platform}
pushd %{_target_platform}
%{cmake_kde4} \
  -DPYTHON_LIBRARY=%{_libdir}/libpython%{python_ver}.so.1.0 \
  -DPYTHON_LIBRARIES=%{_libdir}/libpython%{python_ver}.so.1.0 \
  -DPYTHON_INCLUDE_PATH=%{_includedir}/python%{python_ver} \
  %if 0%{?csharp}
    -DENABLE_QYOTO=ON \
  %else
    -DBUILD_csharp=OFF \
  %endif
  %if 0%{?falcon}
    -DENABLE_KROSSFALCON=ON \
  %else
    -DBUILD_falcon=OFF \
  %endif
  %if 0%{?php}
    -DENABLE_PHP-QT=ON \
  %else
    -DBUILD_php=OFF \
  %endif
  %if 0%{?ruby}
    -DRUBY_SITE_LIB_DIR=%{ruby_sitelib} \
    -DRUBY_SITE_ARCH_DIR=%{ruby_sitearch} \
  %else
    -DBUILD_ruby=OFF \
  %endif
  %if 0%{?smoke}
    -DENABLE_SMOKE=ON \
  %else
    -DBUILD_smoke=OFF \
  %endif
  %if 0%{?java}
    -DENABLE_KROSSJAVA=ON \
  %else
    -DBUILD_java=OFF \
  %endif
  %if 0%{?perl}
    -DBUILD_perl=ON \
  %else
    -DBUILD_perl=OFF \
  %endif
  ../.

make

%install
rm -rf $RPM_BUILD_ROOT
make install/fast DESTDIR=$RPM_BUILD_ROOT -C %{_target_platform}

# HACK: fix multilb conflict, similar to PyQt4's http://bugzilla.redhat.com/509415
#rm -fv %{buildroot}%{_bindir}/pykdeuic4
#mv %{buildroot}%{python_sitearch}/PyQt4/uic/pykdeuic4.py \
#   %{buildroot}%{_bindir}/pykdeuic4
#ln -s %{_bindir}/pykdeuic4 \
#      %{buildroot}%{python_sitearch}/PyQt4/uic/pykdeuic4.py

%if %{smoke}
%files smoke
%defattr(-,root,root)
%{_includedir}/smokegen
%{_bindir}/smokegen
%{_libdir}/libcppparser.so
%{_libdir}/smokegen/generator_dump.so
%{_libdir}/smokegen/generator_smoke.so
%{_bindir}/smokeapi
%{_includedir}/smoke.h
%{_includedir}/smoke
%{_libdir}/libsmoke*.so*
%{_datadir}/smokegen
%endif

%if %{csharp}
%files mono
%defattr(-,root,root)
%_bindir/uics
%_bindir/csrcc
%_libdir/mono/
%_datadir/kde4/services/plasma-scriptengine-kimono-applet.desktop
%_datadir/kde4/services/plasma-scriptengine-kimono-dataengine.desktop
%_includedir/qyoto/
%_datadir/kde4/apps/plasma_scriptengine_kimono/PlasmaScriptengineKimono.dll
%_libdir/libqyoto*
%_libdir/*-sharp*
%_libdir/libkimono*
%_libdir/kde4/kimonopluginfactory.so
%{_pkgconfig}/qtscript-sharp.pc
%{_pkgconfig}/qttest-sharp.pc
%{_pkgconfig}/qtuitools-sharp.pc
%{_pkgconfig}/qtwebkit-sharp.pc
%{_pkgconfig}/qyoto.pc
%endif

%files python
%defattr(-,root,root)
%{python_sitelib}
%_libdir/kde4/krosspython.so
%_libdir/kde4/kpythonpluginfactory.so
%_datadir/kde4/apps/pykde4
#%_datadir/doc/HTML/en/pykde4/
%_datadir/sip/PyKDE4/
%{_bindir}/pykdeuic4
%{_bindir}/puic4
%{python_sitearch}/PyKDE4

%if %{ruby}
%files ruby
%defattr(-,root,root)
%_bindir/krubyapplication
%_bindir/rbkconfig_compiler4
%_bindir/rbqtapi
%_bindir/rbrcc
%_bindir/rbuic4
%_libdir/ruby/
%_libdir/kde4/krossruby.so
%_libdir/kde4/krubypluginfactory.so
%_datadir/kde4/apps/plasma_scriptengine_kimono/PlasmaScriptengineKimono.dll
%_datadir/kde4/apps/dbpedia_references/dbpedia_references.rb
%_datadir/applications/kde4/dbpedia_references.desktop
#%_datadir/kde4/apps/plasma_ruby_web_applet/web_applet.rb
#%_datadir/kde4/apps/plasma_scriptengine_ruby/applet.rb
#%_datadir/kde4/apps/plasma_scriptengine_ruby/data_engine.rb
#%_datadir/kde4/apps/plasma_scriptengine_ruby/package_ruboid.rb
#%_datadir/kde4/apps/plasma_applet_ruby_clock/analog_clock_config.rb
#%_datadir/kde4/apps/plasma_applet_ruby_clock/calendar.rb
#%_datadir/kde4/apps/plasma_applet_ruby_clock/clock.rb
#%_datadir/kde4/apps/plasma_applet_ruby_clock/clockapplet.rb
#%_datadir/kde4/apps/plasma_applet_ruby_clock/timezones_config.rb
#%_datadir/kde4/apps/plasma_ruby_digital_clock/calendar.rb
#%_datadir/kde4/apps/plasma_ruby_digital_clock/clock.rb
#%_datadir/kde4/apps/plasma_ruby_digital_clock/digital_clock_config.rb
#%_datadir/kde4/services/plasma-applet-ruby-analogclock.desktop
#%_datadir/kde4/services/plasma-ruby-digital-clock-default.desktop
#%_datadir/kde4/services/plasma-ruby-applet-web.desktop
#%_datadir/kde4/services/plasma-scriptengine-ruby-applet.desktop
#%_datadir/kde4/services/plasma-scriptengine-ruby-dataengine.desktop
#%_datadir/kde4/services/plasma-scriptengine-ruby-package.desktop
%_includedir/qtruby/
%_libdir/libqtruby*
%endif

%if %{perl}
%files perl
%defattr(-,root,root)
%{_libdir}/kde4/kperlpluginfactory.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KDECore4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KDEUi4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KIO4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Plasma4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtCore4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtCore4/classinfo.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtCore4/debug.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtCore4/isa.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtCore4/signals.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtCore4/slots.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtGui4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtNetwork4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtTest4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtXml4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KDECore4/KDECore4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KDEUi4/KDEUi4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KIO4/KIO4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Plasma4/Plasma4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtCore4/QtCore4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtGui4/QtGui4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtNetwork4/QtNetwork4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtTest4/QtTest4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtXml4/QtXml4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtDBus4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtDBus4/QtDBus4.so
%{_bindir}/prcc4_bin
%{_bindir}/qdbusxml2perl
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Akonadi.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Attica.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KFile.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KHTML.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KNewStuff2.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KNewStuff3.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KParts.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KTextEditor.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/KUtils.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Nepomuk.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/NepomukQuery.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Okular.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Phonon.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QImageBlitz.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Qsci.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Qt3Support4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtHelp4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtMultimedia4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtOpenGL4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtScript4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtSql4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtSvg4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtUiTools4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtWebKit4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/QtXmlPatterns4.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Qwt.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Solid.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/Soprano.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/SopranoClient.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/SopranoServer.pm
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Akonadi/Akonadi.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Attica/Attica.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KFile/KFile.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KHTML/KHTML.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KNewStuff2/KNewStuff2.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KNewStuff3/KNewStuff3.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KParts/KParts.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KTextEditor/KTextEditor.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/KUtils/KUtils.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Nepomuk/Nepomuk.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/NepomukQuery/NepomukQuery.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Okular/Okular.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Phonon/Phonon.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QImageBlitz/QImageBlitz.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Qsci/Qsci.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Qt3Support4/Qt3Support4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtHelp4/QtHelp4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtMultimedia4/QtMultimedia4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtOpenGL4/QtOpenGL4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtScript4/QtScript4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtSql4/QtSql4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtSvg4/QtSvg4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtUiTools4/QtUiTools4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtWebKit4/QtWebKit4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/QtXmlPatterns4/QtXmlPatterns4.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Qwt/Qwt.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Solid/Solid.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/Soprano/Soprano.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/SopranoClient/SopranoClient.so
%{_libdir}/perl5/site_perl/5.10.0/i686-linux-thread-multi/auto/SopranoServer/SopranoServer.so
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Dec 03 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.5.4-1
- Version Update
* Wed Oct 06 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.5.2-1
- Version Update
* Wed Sep 01 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.5.1-1
- Version Update
* Tue Aug 10 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.5.0-1
- Version Update
* Wed Jul 28 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.95-1
- Version Update
* Thu Jul 08 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.92-1
- Version Update - experimental package branch - rc2
- temp disabled qwt
* Tue Jun 29 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.90-1
- Version Update - experimental package branch - rc1
* Wed Jun 02 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.4-1
- Version Update
* Thu May 06 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.3-1
- Version Update
* Wed Mar 31 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.2-1
- Version Update
* Thu Mar 04 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.1-1
- Version Update
* Wed Feb 10 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.4.0-1
- Version Update
* Wed Dec 02 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.3.4-1
- Version Update
* Thu Nov 19 2009 Christian Metzen <metzench@ccux-linux.de> 4.3.3-2
- python 2.6
- temp disable ruby and smoke
* Wed Nov 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.3.3-1
- Version Update
* Mon Oct 26 2009 Christian Metzen <metzench@ccux-linux.de> 4.3.2-2
- rebuild against python25
* Wed Oct 07 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.3.2-1
- Version Update
* Thu Sep 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.3.1-1
- Version Update
* Sat Aug 08 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.3.0-1
- version update
* Thu Jan 15 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.1.96-2
- reenabled mono-bindings
* Sat Jan 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.1.96-1
- version update
* Wed Jan 06 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.1.87-1
- version update
* Sat Dec 13 2008 Karsten Brockmann <arcam@ccux-linux.de> 4.1.85-1
- version update
- temporarily disabled mono-bindings (needs newer mono)
* Fri Nov 28 2008 Karsten Brockmann <arcam@ccux-linux.de> 4.1.80-1
- version update
* Wed Nov 05 2008 Karsten Brockmann <arcam@ccux-linux.de> 4.1.3-1
- version update
* Fri Oct 03 2008 Karsten Brockmann <arcam@ccux-linux.de> 4.1.2-1
- Version update
* Sun Feb 24 2008 Karsten Brockmann <arcam@ccux-linux.de> 3.5.9-1
- Version update
* Tue May 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 3.5.7-1
- Version update
* Thu Oct 12 2006 Karsten Brockmann <arcam@ccux-linux.de> 3.5.5-1
- Initial Release
